/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of this project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND THE CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR THE CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * tiny exceptions entry point (ppc)
 */

	.text
	.align	4

	.global _ext_interrupt

/* __no floating point in isr__ */

_ext_interrupt:

	/* save special purpose registers */

	mfctr	r2
	stwu	r2, -4(sp)
	mfxer	r2
	stwu	r2, -4(sp)
	mfspr	r2, dsisr
	stwu	r2, -4(sp)
	mfspr	r2, dar
	stwu	r2, -4(sp)
	mfspr	r2, srr1
	stwu	r2, -4(sp)
	mfspr	r2, srr0
	stwu	r2, -4(sp)

	/* save general purpose registers */

	stwu	r0, -4(sp)
	/* r1 = sp */
/*	stwu	r2, -4(sp)	*/
	stwu	r3, -4(sp)
	stwu	r4, -4(sp)
	stwu	r5, -4(sp)
	stwu	r6, -4(sp)
	stwu	r7, -4(sp)
	stwu	r8, -4(sp)
	stwu	r9, -4(sp)
	stwu	r10, -4(sp)
	stwu	r11, -4(sp)
	stwu	r12, -4(sp)
	stwu	r13, -4(sp)
	stwu	r14, -4(sp)
	stwu	r15, -4(sp)
	stwu	r16, -4(sp)
	stwu	r17, -4(sp)
	stwu	r18, -4(sp)
	stwu	r19, -4(sp)
	stwu	r20, -4(sp)
	stwu	r21, -4(sp)
	stwu	r22, -4(sp)
	stwu	r23, -4(sp)
	stwu	r24, -4(sp)
	stwu	r25, -4(sp)
	stwu	r26, -4(sp)
	stwu	r27, -4(sp)
	stwu	r28, -4(sp)
	stwu	r29, -4(sp)
	stwu	r30, -4(sp)
	stwu	r31, -4(sp)	/* r31 <= sp */

	/* linkage area / void except_ei_hdlr(void) */
	/* 0(sp) = sp */
	/* 4(sp) = cr */
    /* 8(sp) = lr */

	addi	sp, sp, -12	/* 3 words */
	stw		sp, 0(sp)

	bl except_ei_hdlr

	addi	sp, sp, 12

_ei_epilog:

	/* restore general purpose registers */

	lwzu	r31, 0(sp)
	lwzu	r30, 4(sp)
	lwzu	r29, 4(sp)
	lwzu	r28, 4(sp)
	lwzu	r27, 4(sp)
	lwzu	r26, 4(sp)
	lwzu	r25, 4(sp)
	lwzu	r24, 4(sp)
	lwzu	r23, 4(sp)
	lwzu	r22, 4(sp)
	lwzu	r21, 4(sp)
	lwzu	r20, 4(sp)
	lwzu	r19, 4(sp)
	lwzu	r18, 4(sp)
	lwzu	r17, 4(sp)
	lwzu	r16, 4(sp)
	lwzu	r15, 4(sp)
	lwzu	r14, 4(sp)
	lwzu	r13, 4(sp)
	lwzu	r12, 4(sp)
	lwzu	r11, 4(sp)
	lwzu	r10, 4(sp)
	lwzu	r9, 4(sp)
	lwzu	r8, 4(sp)
	lwzu	r7, 4(sp)
	lwzu	r6, 4(sp)
	lwzu	r5, 4(sp)
	lwzu	r4, 4(sp)
	lwzu	r3, 4(sp)
/*	lwzu	r2, 4(sp)	*/
	/* r1 = sp */
	lwzu	r0, 4(sp)

	/* restore special purpose registers */

	lwzu	r2, 4(sp)
	mtsrr0	r2
	lwzu	r2, 4(sp)
	mtsrr1	r2
	lwzu	r2, 4(sp)
	mtspr	dar, r2
	lwzu	r2, 4(sp)
	mtspr	dsisr, r2
	lwzu	r2, 4(sp)
	mtxer	r2
	lwzu	r2, 4(sp)
	mtctr	r2

	/* restore early init */

	lwzu r2,4(sp)
	mtlr r2
	lwzu r2,4(sp)
	mtcr r2

	mfsprg2	r2
	mfsprg1	sp

	rfi
