/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

/* VESA standard timings */

#ifndef __VESA_H__
#define __VESA_H__

#include <dpy.h>

/* sync polarities: 0 = negative / 1 = positive */

static const dpy_mode_t vesa_640x480_60 = {
	.pxl_clk = 25170,
	.hres = 640,
	.hfp = 16,
	.hspw = 96,
	.hbp = 48,
	.hspol = 0,
	.vres = 480,
	.vfp = 11,
	.vspw = 2,
	.vbp = 31,
	.vspol = 0,
};

static const dpy_mode_t vesa_800x600_60 = {
	.pxl_clk = 40000,
	.hres = 800,
	.hfp = 40,
	.hspw = 128,
	.hbp = 88,
	.hspol = 1,
	.vres = 600,
	.vfp = 1,
	.vspw = 4,
	.vbp = 23,
	.vspol = 1,
};

static const dpy_mode_t vesa_800x600_75 = {
	.pxl_clk = 49500,
	.hres = 800,
	.hfp = 16,
	.hspw = 80,
	.hbp = 160,
	.hspol = 1,
	.vres = 600,
	.vfp = 1,
	.vspw = 2,
	.vbp = 21,
	.vspol = 1,
};

static const dpy_mode_t vesa_1024x768_60 = {
	.pxl_clk = 65000,
	.hres = 1024,
	.hfp = 24,
	.hspw = 136,
	.hbp = 160,
	.hspol = 0,
	.vres = 768,
	.vfp = 3,
	.vspw = 6,
	.vbp = 29,
	.vspol = 0,
};

#endif /* __VESA_H__ */
